/* Color.cpp provides the implementation of class Color operations
 * ...
 ********************************************************************/

#include "Color.h"                                     // class Color

// ------- Wavelength -------------------------------------------------

double Color::Wavelength() const
{
   switch (myColorValue)    
   {
      case RED:
	           return 6.5E-7;
      case ORANGE:
		   return  6.0E-7;
      case YELLOW:
		   return 5.8E-7;
      case GREEN:
		   return 5.2E-7;
      case BLUE:
		   return 4.7E-7;
      case INDIGO:
		   return 4.4E-7;
      case VIOLET:
		   return 4.1E-7;
   }
}

// ------- Input Function Member ----------------------------------------

#include <string>                         // string
#include <cstdlib>                        // exit()
void Color::Read(istream & in)
{
   string colorString;                                // read string
   in >> colorString;

   for (int i = 0; i < colorString.size(); i++)       // convert case
      if (islower(colorString[i]))                    // if needed
	 colorString[i] = toupper(colorString[i]);

   if (colorString == "RED")                          // map to ColorValue
      myColorValue = RED;
   else if (colorString == "ORANGE")
     myColorValue = ORANGE;
   else if (colorString == "YELLOW")
     myColorValue = YELLOW;
   else if (colorString == "GREEN")
     myColorValue = GREEN;
   else if (colorString == "BLUE")
     myColorValue = BLUE;
   else if (colorString == "INDIGO")
     myColorValue = INDIGO;
   else if (colorString == "VIOLET")
     myColorValue = VIOLET;
   else
   {
      cerr << "\n*** Read: invalid color received!\n";
      exit(1);
   }
}


// ------- Output Function Member ----------------------------------------
void Color::Print(ostream & out) const
{
   switch (myColorValue)
   {
      case RED:
                   out << "RED";
      case ORANGE:
		   out << "ORANGE";
      case YELLOW:
		   out << "YELLOW";
      case GREEN: 
		   out << "GREEN";
      case BLUE:
		   out << "RED";
      case INDIGO:
		   out << "INDIGO";
      case VIOLET:
		   out << "VIOLET";
   }
}

// -------- Prefix Increment ----------------------------------------

Color Color::operator++()
{
   switch(myColorValue)
   {
      case RED:
                   myColorValue = ORANGE;
                   break;
      case ORANGE:
		   myColorValue = YELLOW;
                   break;
      case YELLOW:
		   myColorValue = GREEN;
                   break;
      case GREEN:
		   myColorValue = BLUE;
                   break;
      case BLUE:
		   myColorValue = INDIGO;
                   break;
      case INDIGO:
		   myColorValue = VIOLET;
                   break;
      case VIOLET:
		   myColorValue = COLOR_OVERFLOW;
                   break;
   }

   return Color(myColorValue);
}

// -------- Postfix Increment ---------------------------------------

Color Color::operator++(int)
{
   Color myOriginalColor(myColorValue);

   switch(myColorValue)
   {
      case RED:
                   myColorValue = ORANGE;
                   break;
      case ORANGE:
		   myColorValue = YELLOW;
                   break;
      case YELLOW:
		   myColorValue = GREEN;
                   break;
      case GREEN:
		   myColorValue = BLUE;
                   break;
      case BLUE:
		   myColorValue = INDIGO;
                   break;
      case INDIGO:
		   myColorValue = VIOLET;
                   break;
      case VIOLET:
		   myColorValue = COLOR_OVERFLOW;
                   break;
   }

   return myOriginalColor;
}

// ... remaining operators omitted





